heat_template_version: pike

description: >
  OpenStack containerized Cinder API service

parameters:
  DockerCinderApiImage:
    description: image
    type: string
  DockerCinderConfigImage:
    description: The container image to use for the cinder config_volume
    type: string
  EndpointMap:
    default: {}
    description: Mapping of service endpoint -> protocol. Typically set
                 via parameter_defaults in the resource registry.
    type: json
  ServiceData:
    default: {}
    description: Dictionary packing service data
    type: json
  ServiceNetMap:
    default: {}
    description: Mapping of service_name -> network name. Typically set
                 via parameter_defaults in the resource registry.  This
                 mapping overrides those in ServiceNetMapDefaults.
    type: json
  DefaultPasswords:
    default: {}
    type: json
  RoleName:
    default: ''
    description: Role name on which the service is applied
    type: string
  RoleParameters:
    default: {}
    description: Parameters specific to the role
    type: json
  EnableInternalTLS:
    type: boolean
    default: false
  EnableOnlineDataMigrations:
    type: boolean
    description: Enable post-upgrade online data migrations.
    default: true
  UpgradeRemoveUnusedPackages:
    default: false
    description: Remove package if the service is being disabled during upgrade
    type: boolean

conditions:

  internal_tls_enabled: {equals: [{get_param: EnableInternalTLS}, true]}
  online_data_migrations_enabled: {equals: [{get_param: EnableOnlineDataMigrations}, true]}

resources:

  ContainersCommon:
    type: ./containers-common.yaml

  MySQLClient:
    type: ../../puppet/services/database/mysql-client.yaml

  CinderBase:
    type: ../../puppet/services/cinder-api.yaml
    properties:
      EndpointMap: {get_param: EndpointMap}
      ServiceData: {get_param: ServiceData}
      ServiceNetMap: {get_param: ServiceNetMap}
      DefaultPasswords: {get_param: DefaultPasswords}
      RoleName: {get_param: RoleName}
      RoleParameters: {get_param: RoleParameters}

  OnlineDataMigrationsCommand:
    type: OS::Heat::Value
    properties:
      type: string
      value:
        if:
          - online_data_migrations_enabled
          - "/usr/bin/bootstrap_host_exec cinder_api su cinder -s /bin/bash -c 'cinder-manage db online_data_migrations'"
          - "/usr/bin/echo Online data migrations disabled via EnableOnlineDataMigrations parameter"

outputs:
  role_data:
    description: Role data for the Cinder API role.
    value:
      service_name: {get_attr: [CinderBase, role_data, service_name]}
      config_settings: {get_attr: [CinderBase, role_data, config_settings]}
      logging_source: {get_attr: [CinderBase, role_data, logging_source]}
      logging_groups: {get_attr: [CinderBase, role_data, logging_groups]}
      step_config: &step_config
        list_join:
          - "\n"
          - - {get_attr: [CinderBase, role_data, step_config]}
            - {get_attr: [MySQLClient, role_data, step_config]}
      service_config_settings: {get_attr: [CinderBase, role_data, service_config_settings]}
      # BEGIN DOCKER SETTINGS
      puppet_config:
        config_volume: cinder
        puppet_tags: cinder_config,file,concat,file_line
        step_config: *step_config
        config_image: {get_param: DockerCinderConfigImage}
      kolla_config:
        /var/lib/kolla/config_files/cinder_api.json:
          command: /usr/sbin/httpd -DFOREGROUND
          config_files:
            - source: "/var/lib/kolla/config_files/src/*"
              dest: "/"
              merge: true
              preserve_properties: true
          permissions:
            - path: /var/log/cinder
              owner: cinder:cinder
              recurse: true
        /var/lib/kolla/config_files/cinder_api_cron.json:
          command: /usr/sbin/crond -n
          config_files:
            - source: "/var/lib/kolla/config_files/src/*"
              dest: "/"
              merge: true
              preserve_properties: true
          permissions:
            - path: /var/log/cinder
              owner: cinder:cinder
              recurse: true
      docker_config:
        step_2:
          cinder_api_init_logs:
            image: &cinder_api_image {get_param: DockerCinderApiImage}
            privileged: false
            user: root
            volumes:
              - /var/log/containers/cinder:/var/log/cinder
              - /var/log/containers/httpd/cinder-api:/var/log/httpd
            command: ['/bin/bash', '-c', 'chown -R cinder:cinder /var/log/cinder']
        step_3:
          cinder_api_db_sync:
            image: *cinder_api_image
            net: host
            privileged: false
            detach: false
            user: root
            volumes:
              list_concat:
                - {get_attr: [ContainersCommon, volumes]}
                -
                  - /var/lib/config-data/cinder/etc/cinder/:/etc/cinder/:ro
                  - /var/log/containers/cinder:/var/log/cinder
                  - /var/log/containers/httpd/cinder-api:/var/log/httpd
            command:
              - '/usr/bin/bootstrap_host_exec'
              - 'cinder_api'
              - "su cinder -s /bin/bash -c 'cinder-manage db sync'"
        step_4:
          cinder_api:
            image: *cinder_api_image
            net: host
            privileged: false
            restart: always
            # NOTE(mandre) kolla image changes the user to 'cinder', we need it
            # to be root to run httpd
            user: root
            volumes:
              list_concat:
                - {get_attr: [ContainersCommon, volumes]}
                -
                  - /var/lib/kolla/config_files/cinder_api.json:/var/lib/kolla/config_files/config.json:ro
                  - /var/lib/config-data/puppet-generated/cinder/:/var/lib/kolla/config_files/src:ro
                  - /var/log/containers/cinder:/var/log/cinder
                  - /var/log/containers/httpd/cinder-api:/var/log/httpd
                  -
                    if:
                      - internal_tls_enabled
                      - /etc/pki/tls/certs/httpd:/etc/pki/tls/certs/httpd:ro
                      - ''
                  -
                    if:
                      - internal_tls_enabled
                      - /etc/pki/tls/private/httpd:/etc/pki/tls/private/httpd:ro
                      - ''
            environment:
              - KOLLA_CONFIG_STRATEGY=COPY_ALWAYS
        step_5:
          cinder_api_online_migrations:
            start_order: 2
            image: *cinder_api_image
            net: host
            privileged: false
            detach: false
            user: root
            volumes:
              list_concat:
                - {get_attr: [ContainersCommon, volumes]}
                -
                  - /var/lib/config-data/cinder/etc/my.cnf.d/tripleo.cnf:/etc/my.cnf.d/tripleo.cnf:ro
                  - /var/lib/config-data/cinder/etc/cinder/:/etc/cinder/:ro
                  - /var/log/containers/cinder:/var/log/cinder
                  - /var/log/containers/httpd/cinder-api:/var/log/httpd
            command: {get_attr: [OnlineDataMigrationsCommand, value]}
          cinder_api_cron:
            image: *cinder_api_image
            net: host
            user: root
            privileged: false
            restart: always
            healthcheck:
              test: /bin/true
            volumes:
              list_concat:
                - {get_attr: [ContainersCommon, volumes]}
                -
                  - /var/lib/kolla/config_files/cinder_api_cron.json:/var/lib/kolla/config_files/config.json:ro
                  - /var/lib/config-data/puppet-generated/cinder/:/var/lib/kolla/config_files/src:ro
                  - /var/log/containers/cinder:/var/log/cinder
                  - /var/log/containers/httpd/cinder-api:/var/log/httpd
            environment:
              - KOLLA_CONFIG_STRATEGY=COPY_ALWAYS

      metadata_settings:
        get_attr: [CinderBase, role_data, metadata_settings]
      host_prep_tasks:
        - name: create persistent logs directory
          file:
            path: "{{ item }}"
            state: directory
          with_items:
            - /var/log/containers/cinder
            - /var/log/containers/httpd/cinder-api
        - name: cinder logs readme
          copy:
            dest: /var/log/cinder/readme.txt
            content: |
              Log files from cinder containers can be found under
              /var/log/containers/cinder and /var/log/containers/httpd/cinder-api.
          ignore_errors: true
      upgrade_tasks:
        - name: Check is cinder_api is deployed
          command: systemctl is-enabled openstack-cinder-api
          tags: common
          ignore_errors: True
          register: cinder_api_enabled
        - name: "PreUpgrade step0,validation: Check service openstack-cinder-api is running"
          shell: systemctl is-active --quiet openstack-cinder-api
          when: cinder_api_enabled.rc == 0
          tags: step0,validation
        - name: Stop and disable cinder_api service (pre-upgrade not under httpd)
          tags: step2
          service: name=openstack-cinder-api state=stopped enabled=no
          when: cinder_api_enabled.rc == 0
        - name: check for cinder_api running under apache (post upgrade)
          tags: step2
          shell: "httpd -t -D DUMP_VHOSTS | grep -q cinder"
          register: cinder_api_apache
          ignore_errors: true
        - name: Stop and disable cinder_api service
          tags: step2
          service: name=httpd state=stopped enabled=no
          when: cinder_api_apache.rc == 0
        - name: remove old cinder cron jobs
          tags: step2
          file:
            path: /var/spool/cron/cinder
            state: absent
        - name: Remove httpd package if operator requests it
          yum: name=httpd state=removed
          tags: step2
          ignore_errors: True
          when: {get_param: UpgradeRemoveUnusedPackages}
